package mocman.interpreter;

import java.io.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import mocman.util.awt.*;
import mocman.interpreter.*;
import mocman.interpreter.syntax.*;
import mocman.interpreter.modules.*;

public class Gui extends JFrame
{
	public static void main(String[] args)
	{
		Gui g = new Gui();
		g.setVisible(true);
		g.setSize(800,600);
	}
	private ActionListener timing;
	private Interpreter itp=new Interpreter();
	private Structogram st;
	private javax.swing.Timer tm;
	private Gui t;
	private JTextField tf;
	private Editor editor;

	private void refreshEditor()
	{
		String text = editor.ta.getText()+"\n";
    	int contentCount = editor.ta.getLineCount();
		boolean n=false;
		if (contentCount!=itp.rows.size())
		{
			itp.rows=new Vector<Row>();
			for (int i=0; i<contentCount; i++) {itp.addRow("");}
			n=true;
		}
		//System.out.println(""+itp.rows.size()+","+contentCount);
		editor.bold.setSize(contentCount);
		for (int i=0; i<contentCount; i++) 
		{
			try 
			{
				int rangeStart = editor.ta.getLineStartOffset(i);
				int rangeEnd   = editor.ta.getLineEndOffset(i);
				String line = text.substring(rangeStart, rangeEnd);
				if (line.charAt(line.length()-1)=='\n') line = line.substring(0,line.length()-1);
				if(!itp.rows.get(i).getValue().equals(line))
				{
					itp.setRow(i,line);
					if (itp.rows.get(i).getTree()==null)
					{
						editor.bold.set(i,new Boolean(true));
					}
					else
					{
						editor.bold.set(i,new Boolean(false));
					}
				}
			} 
			catch (Exception e) 
			{
				//e.printStackTrace();
			}
		}
		//editor.refresh();
		itp.reLink();
		st.repaint();	
	}
	
	private void buildMenu()
	{
		JMenuBar menubar=new JMenuBar();
		JMenu m=new JMenu("File");
		JMenuItem mn=new JMenuItem("Open");
		mn.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_O, ActionEvent.CTRL_MASK));
		t=this;
		mn.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				String filename = File.separator+"algo";
				JFileChooser fc = new JFileChooser();
				if (fc.showOpenDialog(t)==JFileChooser.APPROVE_OPTION)
				{
					editor.ta.setText("");
					//itp.load(fc.getSelectedFile().toString());
					try
					{
						String line;
						BufferedReader fs = new BufferedReader(new FileReader(fc.getSelectedFile().toString()));
						line = fs.readLine();
						while (line != null)
						{
							editor.ta.append(line+"\n");
							line = fs.readLine();
						}
						fs.close();
					}
					catch (Exception ex)
					{
					}
					refreshEditor();
				}
			}
		});
		m.add(mn);
		m.addSeparator();
		mn=new JMenuItem("Quit");
		mn.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_X, ActionEvent.CTRL_MASK));
		mn.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				System.exit(0);
			}
		});
		m.add(mn);
		menubar.add(m);
		m=new JMenu("Control");
		mn=new JMenuItem("Step");
		mn.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F8,0));
		mn.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				itp.Step();
				if (itp.getPlaceHolder()==itp.rows.size()) itp.reset();
				st.repaint();
			}
		});
		m.add(mn);
		mn=new JMenuItem("Start over");
		mn.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F2,0));
		mn.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				itp.reset();
				st.repaint();
			}
		});
		m.add(mn);
		mn=new JMenuItem("Run");
		mn.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F5,0));
		mn.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				itp.run();
				st.repaint();
			}
		});
		m.add(mn);
		mn=new JMenuItem("Start timer");
		mn.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F5, ActionEvent.SHIFT_MASK));
		mn.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				if (tm==null)tm=new javax.swing.Timer(1000, timing);
				tm.start();
			}
		});
		m.add(mn);
		mn=new JMenuItem("Stop timer");
		mn.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F6, ActionEvent.SHIFT_MASK));
		mn.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				if (tm!=null) tm.stop();
			}
		});
		m.add(mn);
		menubar.add(m);
		m=new JMenu("Graph");
		mn=new JMenuItem("Hide");
		m.add(mn);
		mn.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				IntGraph.f.setVisible(false);
			}
		});
		mn=new JMenuItem("Show");
		m.add(mn);
		mn.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				IntGraph.f.setVisible(true);
			}
		});
		menubar.add(m);
		setJMenuBar(menubar);
	}
	
	public void addButtons(JPanel pnl2)
	{
		JButton btn=new JButton();
		btn.setText("Step");
		pnl2.add(btn);
		btn.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				itp.Step();
				if (itp.getPlaceHolder()==itp.rows.size()) itp.reset();
				st.repaint();
			}
		});
		btn=new JButton();
		btn.setText("Run");
		pnl2.add(btn);
		btn.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				itp.run();
				st.repaint();
			}
		});
		timing = new ActionListener() {
		public void actionPerformed(ActionEvent evt) 
		{
			itp.Step();
			st.repaint();
			if (itp.getPlaceHolder()==itp.rows.size()) 
			{
				tm.stop();
				itp.reset();
			}
		}
		};
		btn=new JButton();
		btn.setText("Start timer");
		pnl2.add(btn);
		btn.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				if (tm==null)tm=new javax.swing.Timer(1000, timing);
				tm.start();
			}
		});
		btn=new JButton();
		btn.setText("Stop timer");
		pnl2.add(btn);
		btn.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				if (tm!=null) tm.stop();
			}
		});
	}
	
	public Gui()
	{
		setTitle("Grafit GUI");
		Generated.generate();
		IntGraph p = new IntGraph();
		itp=new Interpreter();
		st=new Structogram(itp);
		buildMenu();
		
		setLayout(new BorderLayout());
		JPanel pnl=new JPanel();
		pnl.setLayout(new GridLayout(1,2));
		JTextArea ta;
		Editor ed = new Editor();
		editor=ed;
		//ed.setOpaque(false);
		ed.setFont(new Font("monospaced", Font.PLAIN, 12));
		ed.ta.getDocument().addDocumentListener( new DocumentListener()
		{
			public void changedUpdate(DocumentEvent e)
			{
				refreshEditor();
			}
			public void removeUpdate(DocumentEvent e)
			{
				refreshEditor();
			}
			public void insertUpdate(DocumentEvent e)
			{
				refreshEditor();
			}
		});
		JScrollPane scrollingArea;// = new JScrollPane(ta);
		//pnl.add(scrollingArea);
		pnl.add(ed);
		pnl.add(st);
		itp.reLink();
		add("Center",pnl);

		pnl=new JPanel();
		pnl.setLayout(new BorderLayout());
		JPanel pnl2=new JPanel();
		pnl.add("South",pnl2);
		add("South",pnl);

		addButtons(pnl2);

		addWindowListener(new WindowAdapter()
		{
      		public void windowClosing(WindowEvent we)
			{
        		System.exit(0);
      		}
    	});	
		tf = new JTextField();
		//tf.setBackground(Color.black);
		//tf.setForeground(Color.white);
		tf.setFont(new Font("monospaced", Font.PLAIN, 12));
		tf.addActionListener( new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				String text = tf.getText();
				InterpreterTest.tester(text);
				tf.setText("");
			}
		}
		);
		pnl.add("Center",tf);
		ta = new JTextArea(6,20);
		ta.setFont(new Font("monospaced", Font.PLAIN, 12));
		ta.setEditable(false);
		ta.setBackground(Color.black);
		ta.setForeground(Color.white);
		scrollingArea = new JScrollPane(ta);
		OutputHandler.add(new GuiHandler(ta));
		pnl.add("North",scrollingArea);
	}
}
