package mocman.interpreter;

import mocman.interpreter.syntax.*;
import mocman.interpreter.*;
import java.io.*;
import java.util.*;
import java.util.regex.*;
public class ITest
{
	public static void run(String f)
	{
		Interpreter intp=new Interpreter();
		int lc=1;
		try
		{
			String line;
			BufferedReader fs = new BufferedReader(new FileReader(f));
			line = fs.readLine();
			while (line != null)
			{
				intp.addRow(line);
				line = fs.readLine();
				lc++;
			}
			fs.close();
		}
		catch (Exception e)
		{
			System.out.println("Error in execution at line "+lc);
			e.printStackTrace();
		}
		int err=intp.check();
		if (err!=-1)
		{
			System.out.println("Syntax error in file: `"+f+"' at line "+(err+1));
			return;
		}
		intp.reLink();
		//System.out.println("running");
		intp.run();
	}
	public static void main(String[] args)
	{
		Generated.generate();
		OutputHandler.add(new PrintHandler());
		if (args.length<1) return;
		run(args[0]);
		Module.close();
	}
}
