package mocman.interpreter;

import mocman.interpreter.syntax.*;
import mocman.interpreter.syntax.token.*;
import java.util.*;
import java.io.*;
import mocman.util.*;
import mocman.interpreter.*;

public class Interpreter
{
	public Vector<Row> rows=new Vector<Row>();
	private Stack<Pair<Integer,Integer>> estack=new Stack<Pair<Integer,Integer>>();
	private int ph;//placeholder
	public int getPlaceHolder()
	{
		return ph;
	}

	public void load(String f)
	{
		rows=new Vector<Row>();
		ph=0;
		int lc=1;
		try
		{
			String line;
			BufferedReader fs = new BufferedReader(new FileReader(f));
			line = fs.readLine();
			while (line != null)
			{
				addRow(line);
				line = fs.readLine();
				lc++;
			}
			fs.close();
		}
		catch (Exception e)
		{
			System.out.println("Error in execution at line "+lc);
			e.printStackTrace();
		}
	}

	public Interpreter()
	{
			ph=0;
	}
	public void setRow(int i,String s)
	{
		rows.set(i,new Row());
		rows.get(i).place=i;
		rows.get(i).build(s);
		//reLink();
	}
	public void deleteRow(int k)
	{
		for (int i=k;i<rows.size()-1;i++)
		{
			rows.set(i,rows.get(i+1));
		}
		//reLink();
	}
	public void addRow(int i,String s)
	{
		Row p=new Row();
		p.build(s);
		rows.addElement(null);
		for (int k=rows.size()-2;k>=i;k++)
		{
			rows.set(k+1,rows.get(k));
		}
		rows.set(i,p);
		//reLink();
	}
	public void addRow(String s)
	{
		//System.out.println("adding line"+s);
		Row p=new Row();
		p.build(s);
		rows.addElement(p);
		//reLink();
	}
	public int check()
	{
		for (int i=0;i<rows.size();i++)
		{
			if (rows.get(i).getTree()==null) return i;
		}
		return -1;
	}
	public void reLink()
	{
		ph=0;
		for (int i=0;i<rows.size();i++)
		{
			rows.get(i).place=i;
			rows.get(i).placeT=i+1;
			rows.get(i).placeF=i+1;
		}
		for (int i=0;i<rows.size();i++)
		{
			SyntaxTree t=rows.get(i).getTree();
			if (t!=null)
			{
				int k=t.getChild();
				if (Tokenizer.getTokenName(k).equals("PROCEDURE")) {Local.push();estack.push(new Pair<Integer,Integer>(new Integer(i),new Integer(k)));}
				if (Tokenizer.getTokenName(k).equals("IF")) estack.push(new Pair<Integer,Integer>(new Integer(i),new Integer(k)));
				if (Tokenizer.getTokenName(k).equals("WHILE")) {estack.push(new Pair<Integer,Integer>(new Integer(i),new Integer(k)));}
				if (Tokenizer.getTokenName(k).equals("ELSE")) 
				{
					//if (estack.size()==0) return;
					Pair<Integer,Integer> p=estack.peek();
					rows.get(p.getKey()).placeF=i+1;
					estack.push(new Pair<Integer,Integer>(new Integer(i),new Integer(k)));
				}
				if (Tokenizer.getTokenName(k).equals("end")) 
				{
					if (estack.size()==0) return;
					Pair<Integer,Integer> p=estack.peek();
				//System.out.println("F:"+Tokenizer.getTokenName(rows.get(p.getKey()).getTree().getChild()));
					if (Tokenizer.getTokenName(rows.get(p.getKey()).getTree().getChild()).equals("IF"))
					{
						estack.pop();
						rows.get(p.getKey()).placeF=i+1;
					}else
					if (Tokenizer.getTokenName(rows.get(p.getKey()).getTree().getChild()).equals("PROCEDURE"))
					{
						Local.pop();
						estack.pop();
						rows.get(p.getKey()).placeF=i+1;
					}else
					if (Tokenizer.getTokenName(rows.get(p.getKey()).getTree().getChild()).equals("WHILE"))
					{
						estack.pop();
						rows.get(p.getKey()).placeF=i+1;
						rows.get(i).placeT=p.getKey();
					}else
					if (Tokenizer.getTokenName(rows.get(p.getKey()).getTree().getChild()).equals("ELSE"))
					{
						estack.pop();
						if (estack.size()==0) return;
						rows.get(p.getKey()).placeT=i+1;
						rows.get(p.getKey()).placeF=i+1;
						p=estack.pop();
						//rows.get(p.getKey()).placeF
					}
				}
				//System.out.println(Tokenizer.getTokenName(t.getChild()));
			}
		}
	}
	public void Step()
	{
		//System.out.println("Step:"+ph);
		ph=rows.get(ph).run();
		try
		{
			if (rows.get(ph).getTree()==null) Step();
			String s=Tokenizer.getTokenName(rows.get(ph).getTree().getChild());
			//System.out.println(s);
			if (s.equals("end")) Step();
		}
		catch (Exception e)
		{
		}
//		System.out.println("");
	}
	public void reset()
	{
		ph=0;
	}
	public void run()
	{
		while (ph<rows.size())
		{
			Step();
		}
		ph=0;
	}
}
