package mocman.interpreter;

import mocman.interpreter.syntax.*;
import mocman.interpreter.*;
import java.io.*;
import java.util.*;
import java.util.regex.*;
import mocman.interpreter.modules.*;
class InterpreterTest
{
	private static Global global=new Global();
	private static Local local=new Local();
	private static Row r = new Row();
	public static void tester(String s)
	{
		if (s.equals("")) return; //empty
		if (s.charAt(0)=='#') return; //comment
		if (s.charAt(0)==':') //command
		{
			if (s.equals(":show Graph"))
			{
				IntGraph g=new IntGraph();
				IntGraph.f.setVisible(true);
			}
			if (s.equals(":hide Graph"))
			{
				IntGraph g=new IntGraph();
				IntGraph.f.setVisible(false);
			}
			if (Pattern.compile(":run\\s*(.*)").matcher(s).matches())
			{
				Local.push();
				System.out.println("#Running: "+s.replaceAll(":run\\s*(.*)","$1"));
				ITest.run(s.replaceAll(":run\\s*(.*)","$1"));
				System.out.println("#Job complete");
				Local.pop();
			}
			return;
		}
		SyntaxTree t=r.build(s);
		if (r.isCorrect())
		{
			//System.out.println(s);
			t.run();
			//if (s2!="") System.out.println(s2+"="+global.get(s2));
			//if (s2!="") System.out.println(s2+"="+local.get(s2));
		}
		else
		{
			System.out.println("Syntax error");
		}
	}
	public static void main(String[] args)
	{
		Generated.generate();
		Console in = System.console();
		String inp="";
		OutputHandler.add(new PrintHandler());
		System.out.println("Welcome to the interpreter tester!");
		System.out.println("Write down a row and I will run it!");
		System.out.println("Enter return to quit.");
		while (!Pattern.compile("^return").matcher(inp).matches())
		{
			System.out.print("> ");
			try
			{
				tester(inp=in.readLine());
			}
			catch (Exception e)
			{
				e.printStackTrace();
			}
		}
		Module.close();
		//in.close();
/*		tester("$global.a:=2","");
		tester("a:=3","a");
		tester("b:=$global.a+a","b");*/
/*		tester("a:=5","a");
		tester("b:=6","b");
		tester("a:=b","a");*/
	}
}
