package mocman.interpreter;

import mocman.interpreter.syntax.*;
import mocman.interpreter.syntax.token.*;
import java.util.*;
import mocman.util.*;
import mocman.interpreter.*;

/**
This class makes the rule sequence for the AST
*/
class Row
{
	public int place;
	public int placeF;
	public int placeT;
	private String strValue;
	private SyntaxTree tree;
	private boolean error=true;
	
	public Row()
	{
	}
	
	public int run()
	{
		if (tree!=null) 
		{
			ITreeNode n=tree.run();
			//System.out.println("V:"+n.getVal()+"T:"+placeT+"F:"+placeF);
			if (n.getVal().equals("0"))
			{
				return placeF;
			}
		}
		return placeT;
	}
	public SyntaxTree getTree()
	{
		return tree;
	}
	public boolean isCorrect()
	{
		return !error;
	}

	public SyntaxTree build(String s)
	{
		error=false;
		strValue=s;
		Tokenizer tokens=new Tokenizer();
		tokens.tokenize(s);
		Stack<Token> terms=new Stack<Token>();
		Stack<Token> termstack = new Stack<Token>();
		Stack<Integer> rules=new Stack<Integer>();
		Vector<Integer> sequence=new Vector<Integer>();
		Stack<Token> totree=new Stack<Token>();
//		rules.push(Rules.getStartRule());
		rules.push(100);
		while(tokens.hasNext())
		{
			terms.push(tokens.getNext());
		}
		terms.push(new Token("#",Rules.getHash()));
		while(!terms.empty())
		{
			totree.push(terms.peek());
			termstack.push(terms.pop());
		}
		//Stack<Token> totree=(Stack<Token>)termstack.clone();
		//ELEMZÉS
		while((!termstack.empty())&&(!rules.empty()))
		{
			if (termstack.peek().getType()==rules.peek())
			{
				//System.out.println("POP:"+termstack.peek().getCode());
				termstack.pop();
				rules.pop();
			}
			else
			{
				int ntp=rules.peek();
				//System.out.println(""+Tokenizer.getTokenName(ntp)+"<->"+termstack.peek().getCode()+"("+termstack.peek().getType()+")");
				//ntp=Tokenizer.getPatternId(ntp);
				//System.out.println(""+ntp+","+Tokenizer.getTokenName(termstack.peek().getType()));
				int r=ParserTable.get(new Integer(ntp),termstack.peek().getType());
				//System.out.println(r);
				if (r==ParserTable.EMPTY)
				{
					error=true;
//					System.out.println("Syntax error");
//					System.out.println("");
					return null;
				}
				if (Rules.getRule(r).getValue().get(0)==Tokenizer.epsilon()) 
				{
					rules.pop();
					sequence.addElement(r);
					//System.out.println(Rules.getRuleName(r));
				}
				else
				{
					rules.pop();
					sequence.addElement(r);
					//System.out.println(r);
					//System.out.println(Rules.getRuleName(r));
					for (int i=Rules.getRule(r).getValue().size()-1;i>=0;i--)
					{
						int nt=Rules.getRule(r).getValue().get(i);
						//System.out.println("nt:"+Tokenizer.getTokenName(nt)+"("+nt+")");
						rules.push(nt);
					}
				}
				
			}
		}

		tree = SyntaxTree.build(sequence,totree);
//		System.out.println("OK");
//		System.out.println("");
		return tree;
	}
	public String getValue()
	{
		return strValue;
	}
}
