package mocman.interpreter.modules;

import java.util.*;
import mocman.interpreter.*;
import mocman.util.*;
import mocman.util.data.*;
import mocman.util.awt.*;
import mocman.interpreter.syntax.*;
import java.awt.*;
import java.awt.event.*;

public class IntGraph extends Module
{
	public static Graph<Integer,Integer> graph;
	public static GraphPrinter<Integer,Integer> gp;
	public static Frame f;
	private static int pw=0;
	private static int ph=0;
	public static void Close()
	{
		if (f!=null) f.setVisible(false);
	}
	public static void resize()
	{
		gp.sizer();
		if ((gp.getWidth()!=pw)||(gp.getHeight()!=ph)) 
		{
			pw = gp.getWidth();
			ph = gp.getHeight();
			f.setSize(pw,ph);
		}
	}
	public static void Repaint()
	{
		resize();
		gp.repaint();
	}
	private String c2i(Color c)
	{
		if (c.equals(Color.blue)) return "1";
		if (c.equals(Color.green)) return "2";
		if (c.equals(Color.cyan)) return "3";
		if (c.equals(Color.red)) return "4";
		if (c.equals(Color.magenta)) return "5";
		if (c.equals(Color.yellow)) return "6";
		if (c.equals(Color.gray)) return "7";
		if (c.equals(Color.darkGray)) return "8";
		if (c.equals(Color.white)) return "15";
		return "0";
	}
	private Color i2c(int i)
	{
		switch(i)
		{
			case 0: return Color.black;
			case 1: return Color.blue;
			case 2: return Color.green;
			case 3: return Color.cyan;
			case 4: return Color.red;
			case 5: return Color.magenta;
			case 6: return Color.yellow;
			case 7: return Color.gray;
			case 8: return Color.darkGray;
			case 9: return Color.blue;
			case 10: return Color.green;
			case 11: return Color.cyan;
			case 12: return Color.red;
			case 13: return Color.magenta;
			case 14: return Color.yellow;
		}
		return Color.white;
	}
	public IntGraph()
	{
		//Singleton létrehozása
		if (graph==null)
		{
			//System.out.println("singleton létrehozása");
			graph=new Graph<Integer,Integer>();
			gp=new GraphPrinter<Integer,Integer> ();
			gp.setAutoSize(true);
			gp.setGraph(graph);
			f=new Frame();
			f.setTitle("Grafit - Graph");
			f.add(gp);
			f.setLayout(new FlowLayout());
			//resize();
			f.addWindowListener(new WindowAdapter()
			{
      			public void windowClosing(WindowEvent we)
				{
					f.setVisible(false);
       	 		//System.exit(0);
      			}
    		});	

			f.setVisible(true);
		}
	}
	public IntGraph clone()
	{
		IntGraph g=new IntGraph();
		g.setValue(getVal());
		return g;
	}

	public ITreeNode value(String s)
	{
		IntGraph l=new IntGraph();
		l.setValue(s);
		return l;
	}
	public ITreeNode get(ITreeNode n)
	{
		if (n.getVal().equals("selectedNode"))
		{
			return Global.svalue((new Integer(gp.selectedNode)).toString());
		}else
		if (n.getVal().equals("selectedEdge"))
		{
			return Global.svalue((new Integer(gp.selectedEdge)).toString());
		}
		System.out.println("$MGraph:: No such variable!");
		return n;
	}
	public ITreeNode set(ITreeNode n,ITreeNode m)
	{
		if (n.getVal().equals("selectedNode"))
		{
			gp.selectedNode=Integer.parseInt(m.getVal());
			Repaint();
			return n;
		}else
		if (n.getVal().equals("selectedEdge"))
		{
			gp.selectedEdge=Integer.parseInt(m.getVal());
			Repaint();
			return n;
		}
		System.out.println("$MGraph:: No such variable!");
		return n;
	}
	public ITreeNode function(ITreeNode n)
	{
		if (getVal().equals("init"))
		{
			graph=new Graph<Integer,Integer>();
			gp.setGraph(graph);
			Repaint();
			return value("1");
		}else
		if (getVal().equals("selectNode"))
		{
			gp.selectedNode=Integer.parseInt(n.getVal());
			Repaint();
			return n;
		}else
		if (getVal().equals("selectEdge"))
		{
			gp.selectedEdge=Integer.parseInt(n.getVal());
			Repaint();
			return n;
		}else
		if ((getVal().equals("getNode"))||(getVal().equals("getNodeValue")))
		{
			int x=gp.selectedNode;
			if (!n.isEpsilon())
			{
				x=Integer.parseInt(n.getVal());
			}
			return value(graph.nodes(x).getValue().toString());
		}
		else
		if ((getVal().equals("getEdgeValue")))
		{
			int x=gp.selectedEdge;
			if (!n.isEpsilon())
			{
				x=Integer.parseInt(n.getVal());
			}
			return value(graph.edges(x).getValue().toString());
		}
		else
		if (getVal().equals("addNode"))
		{
			int x=0;
			int y=0;
			Color c=Color.white;
			if (!n.getNext().isEpsilon())
			{
				x=Integer.parseInt(n.getNext().getVal());
				if (!n.getNext().getNext().isEpsilon())
				{
					y=Integer.parseInt(n.getNext().getNext().getVal());
					if (!n.getNext().getNext().getNext().isEpsilon())
					{
						c=i2c(Integer.parseInt(n.getNext().getNext().getNext().getVal()));
					}
				}
			}
			graph.add(new Node<Integer>(Integer.parseInt(n.getVal()),x,y,c));
			Repaint();
			return n;
		}
		else		if ((getVal().equals("setNode"))||(getVal().equals("setNodeValue")))
		{
			int x=Integer.parseInt(n.getVal());
			int y=0;
			if (!n.getNext().isEpsilon())
			{
				y=Integer.parseInt(n.getNext().getVal());
			}
			graph.nodes(x).setValue(y);
			Repaint();
			return n;
		}
		else

		if ((getVal().equals("setEdge"))||(getVal().equals("setEdgeValue")))
		{
			int x=Integer.parseInt(n.getVal());
			int y=0;
			if (!n.getNext().isEpsilon())
			{
				y=Integer.parseInt(n.getNext().getVal());
			}
			graph.edges(x).setValue(y);
			Repaint();
			return n;
		}
		else
		if (getVal().equals("addEdge"))
		{
			int x=Integer.parseInt(n.getVal());
			int y=-1;
			if (!n.getNext().isEpsilon())
			{
				y=Integer.parseInt(n.getNext().getVal());
			}
			else
			{
				System.out.println("$MGraph:: Not enough parameters!");
				return value("0");
			}
			graph.addEdge(x,y,new Node<Integer>(0));
			//graph.add(new Node<Integer>(Integer.parseInt(n.getVal()),x,y,c));
			Repaint();
			return n;
		}else
		if (getVal().equals("deleteNode"))
		{
			System.out.println("$MGraph:: Not implemented");
			return n;
		}
		else
		if (getVal().equals("setX"))
		{
			graph.nodes(gp.selectedNode).setX(Integer.parseInt(n.getVal()));
			Repaint();
			return n;
		}
		else
		if (getVal().equals("setY"))
		{
			graph.nodes(gp.selectedNode).setY(Integer.parseInt(n.getVal()));
			Repaint();
			return n;
		}
		else
		if ((getVal().equals("setColor"))||(getVal().equals("setNodeColor")))
		{
			graph.nodes(gp.selectedNode).setColor(i2c(Integer.parseInt(n.getVal())));
			Repaint();
			return n;
		}
		else
		if (getVal().equals("setEdgeColor"))
		{
			graph.edges(gp.selectedEdge).setColor(i2c(Integer.parseInt(n.getVal())));
			Repaint();
			return n;
		}
		else
		if (getVal().equals("getX"))
		{
			return value((new Integer(graph.nodes(gp.selectedNode).getX())).toString());
		}
		else
		if ((getVal().equals("getColor"))||(getVal().equals("getNodeColor")))
		{
			return value(c2i(graph.nodes(gp.selectedNode).getColor()));
		}
		else
		if (getVal().equals("getEdgeColor"))
		{
			return value(c2i(graph.edges(gp.selectedEdge).getColor()));
		}
		else
		if (getVal().equals("getY"))
		{
			return value((new Integer(graph.nodes(gp.selectedNode).getY())).toString());
		}
		else
		if (getVal().equals("getEdgeCount"))
		{
			Integer c=0;
			int k=Integer.parseInt(n.getVal());
			for (int i=0;i<graph.edgeCount();i++)
			{
				if (graph.edges(i).getX()==k)
				{
					c++;
				}
			}
			return value(c.toString());
		}
		else
		if ((getVal().equals("nodeCount"))||(getVal().equals("getNodeCount")))
		{
			Integer c=0;
			return value((new Integer(graph.nodeCount())).toString());
		}
		else
		if (getVal().equals("getStartNode"))
		{
			return value((new Integer(graph.edges(Integer.parseInt(n.getVal())).getX())).toString());
		}
		else
		if (getVal().equals("getEndNode"))
		{
			return value((new Integer(graph.edges(Integer.parseInt(n.getVal())).getY())).toString());
		}
		else
		if (getVal().equals("getEdge"))
		{
			Integer c=0;
			int k=Integer.parseInt(n.getVal());
			if (!n.getNext().isEpsilon())
			{
				int p=Integer.parseInt(n.getNext().getVal());
				for (int i=0;i<graph.edgeCount();i++)
				{
					if (graph.edges(i).getX()==k)
					{
						if (c==p) return value((new Integer(i)).toString());
						c++;
					}
				}
				System.out.println("$MGraph:: No such edge");
				return value("0");
			}
			System.out.println("$MGraph:: getEdge must have 2 parameters (startnode,edgeindex)");		
			return value("0");
		}
		System.out.println("$MGraph:: Invalid function call "+getVal());
		return value("0"); //return false
	}
	public static void close()
	{
		if (f!=null) 
		{
			f.setVisible(false);
			f.dispose();
			f=null;
			gp=null;
			graph=null;
		}
	}
}
