package mocman.interpreter.modules;

import java.util.*;
import mocman.util.*;
import mocman.interpreter.*;
import mocman.interpreter.syntax.*;

public class MPQ extends Module
{
	private static HashMap<String,PriorityQueue<Pair<Integer,Integer>>> sorok = new HashMap<String,PriorityQueue<Pair<Integer,Integer>>>();
	private void addTo(String k,Integer a,Integer b)
	{
		if (sorok.get(k)==null)
		{
			sorok.put(k,new PriorityQueue<Pair<Integer,Integer>>());
		}
		sorok.get(k).offer(new Pair<Integer,Integer>(a,b));
	}
	private int getFrom(String k)
	{
		if (sorok.get(k)==null) return 0;
		Pair<Integer,Integer> p=sorok.get(k).poll();
		return p.getValue();
	}
	private int getItemCount(String s)
	{
		if (sorok.get(s)==null) return 0;
		return sorok.get(s).size();
	}
	public MPQ clone()
	{
		MPQ g=new MPQ();
		g.setValue(getVal());
		return g;
	}

	public ITreeNode value(String s)
	{
		MPQ l=new MPQ();
		l.setValue(s);
		return l;
	}

	public ITreeNode get(ITreeNode n)
	{
		return n;
	}
	public ITreeNode set(ITreeNode n,ITreeNode m)
	{
		//System.out.println("$MColor:: Not allowed!");
		return n;
	}
	public ITreeNode function(ITreeNode n)
	{
		if (getVal().equals("push"))
		{
			int x=0;
			int y=0;
			if (!n.getNext().isEpsilon())
			{
				x=Integer.parseInt(n.getNext().getVal());
				if (!n.getNext().getNext().isEpsilon())
				{
					y=Integer.parseInt(n.getNext().getNext().getVal());
				}
			}
			addTo(n.getVal(),x,y);
		}
		else
		if (getVal().equals("pop"))
		{
			Integer k=getFrom(n.getVal());
			return value(k.toString());
		}
		if (getVal().equals("isEmpty"))
		{
			Integer k=getItemCount(n.getVal());
			if (k==0) return value("1");
			return value("0");
		}
		if (getVal().equals("size"))
		{
			Integer k=getItemCount(n.getVal());
			return value(k.toString());
		}
		
		return value("0"); //return false
	}
}
