package mocman.interpreter.syntax;

/**
 * TreeNode interface
 * It contains the semantic value of a syntactic unit
 */
public interface ITreeNode
{
	public ITreeNode clone();
	public ITreeNode value(String s);
	public void setNextOp(ITreeNode t);
	public ITreeNode getNext();
	public boolean isEpsilon();
	public void setRule(int i);
	public String getVal();
	public void setValue(String s);
	public ITreeNode get(ITreeNode i);
	public ITreeNode set(ITreeNode i, ITreeNode v);
	public ITreeNode function(ITreeNode i);
	public void build(String s,int rule);
	public void run(ITreeNode[] p);
	public int getRule();
}
